"""role delete_invoice

Revision ID: b8a9b1667191
Revises: 120d26ab917e
Create Date: 2020-04-25 16:10:41.731338

"""
from alembic import op
import sqlalchemy as sa
import falcon_rest
import api_dnl
import imp,os

#alembic_helpers = imp.load_source('alembic_helpers', ( op.get_context().script.dir + '/alembic_helpers.py'))
#if not alembic_helpers.table_has_column('xxxx', 'yyyy'):



# revision identifiers, used by Alembic.
revision = 'b8a9b1667191'
down_revision = '120d26ab917e'
branch_labels = None
depends_on = None


def upgrade():
    alembic_helpers = imp.load_source('alembic_helpers', (op.get_context().script.dir + '/alembic_helpers.py'))
    if not alembic_helpers.table_has_column('role', 'delete_credit'):
    # ### commands auto generated by Alembic - please adjust! ###
        op.add_column('role', sa.Column('delete_credit', sa.Boolean(), nullable=True))
        op.add_column('role', sa.Column('delete_invoice', sa.Boolean(), nullable=True))
        op.add_column('role', sa.Column('delete_payment', sa.Boolean(), nullable=True))
        op.add_column('role', sa.Column('modify_credit_limit', sa.Boolean(), nullable=True))
        op.add_column('role', sa.Column('modify_min_profit', sa.Boolean(), nullable=True))
        op.add_column('role', sa.Column('reset_balance', sa.Boolean(), nullable=True))
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_column('role', 'reset_balance')
    op.drop_column('role', 'modify_min_profit')
    op.drop_column('role', 'modify_credit_limit')
    op.drop_column('role', 'delete_payment')
    op.drop_column('role', 'delete_invoice')
    op.drop_column('role', 'delete_credit')
    # ### end Alembic commands ###
"""
ADDONS
"""
def up_rec(table):
    """
    create record table and triggers for table
    :return:
    """
    sql= """
    --{table} trigger--
drop trigger IF EXISTS class4_trig_record_{table} on {table};
drop table IF EXISTS {table}_record;
DROP FUNCTION IF EXISTS class4_trigfun_record_{table}();
DROP SEQUENCE IF EXISTS {table}_record_record_id_seq;
SELECT * INTO {table}_record FROM {table} where false;
alter table {table}_record add time numeric;
alter table {table}_record add flag character(1);
alter table {table}_record add record_id integer;
alter table {table}_record alter COLUMN record_id SET NOT NULL;
create SEQUENCE {table}_record_record_id_seq;
alter table {table}_record alter COLUMN record_id SET DEFAULT nextval('{table}_record_record_id_seq'::regclass);

create function class4_trigfun_record_{table}() returns trigger as $$
begin
        if(TG_OP='INSERT')then
                insert into {table}_record select NEW.*,EXTRACT(EPOCH from current_timestamp(0)),'I';
        elseif(TG_OP='DELETE')then
                insert into {table}_record select OLD.*,EXTRACT(EPOCH from current_timestamp(0)),'D';
        elseif(TG_OP='UPDATE')then
                insert into {table}_record select OLD.*,EXTRACT(EPOCH from current_timestamp(0)),'B';
                insert into {table}_record select NEW.*,EXTRACT(EPOCH from current_timestamp(0)),'A';
        end if;
return null;
end;
$$ language plpgsql;

create trigger class4_trig_record_{table} after update or insert or delete on {table} for each row execute procedure class4_trigfun_record_{table}();

create index c4_{table}_record_id_idx on {table}_record (record_id);
create index {table}_record_time_idx on {table}_record using btree (time);
    """
    connection = op.get_bind()
    connection.execute(sql.format_map(dict(table=table)))