"""_count to report fields

Revision ID: 256d47a95cr548
Revises: 1fc4d2e74474
Create Date: 2024-05-21 15:21:33.772356

"""
from alembic import op
import sqlalchemy as sa
import falcon_rest
import api_dnl
import imp,os

#alembic_helpers = imp.load_source('alembic_helpers', ( op.get_context().script.dir + '/alembic_helpers.py'))
#if not alembic_helpers.table_has_column('xxxx', 'yyyy'):

from sqlalchemy.dialects import postgresql

# revision identifiers, used by Alembic.
revision = 'c6cbed60d769'
down_revision = '541e01458586'
branch_labels = None
depends_on = None


def upgrade():
    upgrade_sql = """
BEGIN;

ALTER TABLE cdr_report_detail ADD COLUMN IF NOT EXISTS ani_in_dno_count integer;
ALTER TABLE cdr_report_detail ADD COLUMN IF NOT EXISTS ani_in_ftc_count integer;
ALTER TABLE cdr_report_detail ADD COLUMN IF NOT EXISTS ani_in_ftc_week_count integer;
ALTER TABLE cdr_report_detail ADD COLUMN IF NOT EXISTS ani_in_ftc_month_count integer;
ALTER TABLE cdr_report_detail ADD COLUMN IF NOT EXISTS ani_in_spam_count integer;
ALTER TABLE cdr_report_detail ADD COLUMN IF NOT EXISTS ani_in_fraud_count integer;
ALTER TABLE cdr_report_detail ADD COLUMN IF NOT EXISTS ani_in_tcpa_count integer;
ALTER TABLE cdr_report_detail ADD COLUMN IF NOT EXISTS dnis_in_dnc_count integer;

ALTER TABLE cdr_report_daily ADD COLUMN IF NOT EXISTS ani_in_dno_count integer;
ALTER TABLE cdr_report_daily ADD COLUMN IF NOT EXISTS ani_in_ftc_count integer;
ALTER TABLE cdr_report_daily ADD COLUMN IF NOT EXISTS ani_in_ftc_week_count integer;
ALTER TABLE cdr_report_daily ADD COLUMN IF NOT EXISTS ani_in_ftc_month_count integer;
ALTER TABLE cdr_report_daily ADD COLUMN IF NOT EXISTS ani_in_spam_count integer;
ALTER TABLE cdr_report_daily ADD COLUMN IF NOT EXISTS ani_in_fraud_count integer;
ALTER TABLE cdr_report_daily ADD COLUMN IF NOT EXISTS ani_in_tcpa_count integer;
ALTER TABLE cdr_report_daily ADD COLUMN IF NOT EXISTS dnis_in_dnc_count integer;
ALTER TABLE cdr_report_daily ADD COLUMN IF NOT EXISTS pdd_count bigint;

ALTER TABLE voip_gateway ADD COLUMN IF NOT EXISTS cps integer;
ALTER TABLE voip_gateway ADD COLUMN IF NOT EXISTS cap integer;
ALTER TABLE voip_gateway ADD COLUMN IF NOT EXISTS self_cps integer;
ALTER TABLE voip_gateway ADD COLUMN IF NOT EXISTS self_cap integer;

END;
"""
    connection = op.get_bind()
    connection.execute(upgrade_sql)


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    pass
    # ### end Alembic commands ###

"""
ADDONS
"""
def up_rec(table):
    """
    create record table and triggers for table
    :return:
    """
    sql= """
    --{table} trigger--
drop trigger IF EXISTS class4_trig_record_{table} on {table};
drop table IF EXISTS {table}_record;
DROP FUNCTION IF EXISTS class4_trigfun_record_{table}();
DROP SEQUENCE IF EXISTS {table}_record_record_id_seq;
SELECT * INTO {table}_record FROM {table} where false;
alter table {table}_record add time numeric;
alter table {table}_record add flag character(1);
alter table {table}_record add record_id integer;
alter table {table}_record alter COLUMN record_id SET NOT NULL;
create SEQUENCE {table}_record_record_id_seq;
alter table {table}_record alter COLUMN record_id SET DEFAULT nextval('{table}_record_record_id_seq'::regclass);

create function class4_trigfun_record_{table}() returns trigger as $$
begin
        if(TG_OP='INSERT')then
                insert into {table}_record select NEW.*,EXTRACT(EPOCH from current_timestamp(0)),'I';
        elseif(TG_OP='DELETE')then
                insert into {table}_record select OLD.*,EXTRACT(EPOCH from current_timestamp(0)),'D';
        elseif(TG_OP='UPDATE')then
                insert into {table}_record select OLD.*,EXTRACT(EPOCH from current_timestamp(0)),'B';
                insert into {table}_record select NEW.*,EXTRACT(EPOCH from current_timestamp(0)),'A';
        end if;
return null;
end;
$$ language plpgsql;

create trigger class4_trig_record_{table} after update or insert or delete on {table} for each row execute procedure class4_trigfun_record_{table}();

create index c4_{table}_record_id_idx on {table}_record (record_id);
create index {table}_record_time_idx on {table}_record using btree (time);
    """
    connection = op.get_bind()
    connection.execute(sql.format_map(dict(table=table)))
